﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WinGridWithExcelComments
{
    public partial class Form1 : Form
    {
        private UltraGridCell cell = null;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetupGridData();
            this.ultraGrid1.CreationFilter = new GridCommentImageCreationFilter();
        }

        private void SetupGridData()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("A", typeof(string));
            dt.Columns.Add("B", typeof(string));
            dt.Columns.Add("C", typeof(string));
            for (int i = 0; i < 15; i++)
            {
                dt.Rows.Add(new object[] { i.ToString(), "test", "test " + i.ToString() });
            }
            this.ultraGrid1.DataSource = dt;
        }

        private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
        {
            switch (e.Tool.Key)
            {
                case "Insert Comment":
                    InsertCellComment();
                    break;
            }
        }

        private void InsertCellComment()
        {
            if (cell != null)
            {
                cell.Tag = "ShowCommentImage";
                CellUIElement uieCell = cell.GetUIElement() as CellUIElement;
                if (uieCell != null)
                {
                    Point screenPoint = new Point(uieCell.Rect.Right, uieCell.Rect.Bottom);
                    Point p = this.ultraGrid1.PointToScreen(screenPoint);
                    this.ultraPopupControlContainer1.Show(p);
                }
            }
        }

        private void ultraToolbarsManager1_BeforeToolDropdown(object sender, Infragistics.Win.UltraWinToolbars.BeforeToolDropdownEventArgs e)
        {
            UltraGrid grid = e.SourceControl as UltraGrid;
            if (grid != null)
            {
                Point clientPoint = this.ultraGrid1.PointToClient(Form1.MousePosition);
                UIElement uie = this.ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(clientPoint);
                if (uie != null)
                {
                    cell = uie.GetContext(typeof(UltraGridCell), true) as UltraGridCell;
                }
            }
        }
    }
}
